import java.io.IOException;
import java.net.Socket;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

/*As with PH/PP, OH and OP will each have a net proxy. 
OH will also have a server proxy to decide whether or not to send the button
number out over the network. The OH server proxy will cache the results that 
come back from OP so that if the network is not needed, the previously computed 
result can be reported. The cache will save the previous result for each button number. 
The decision to go remote or not will be made based on wall clock: if the previous result
for the button number was obtained in the last 30 seconds, use it; if it is older than 30 
seconds, go out over the net and get a new result. */
class Record
{
	public int value;
	public long time; 
}
public class OddHandler implements Handler
{
	OddServerProxy proxy=new OddServerProxy();
	public void calculate(int num)
	{
		int result=proxy.calculate(num);
	}
	
	public static void main(String args[])
	{
	
		OddHandler handler = new OddHandler();
		handler.calculate(9);
		handler.calculate(9);
	
	}
	
}

class OddServerProxy 
{
	Record []catche=new Record[225];  
	Proxy proxy=new Proxy();
	public int calculate (int num)
    {
		  long currTime= System.currentTimeMillis();
		  //It is null or it is time out. 
		  if(catche[num]==null ||((catche[num]!=null)&&(double)(currTime-catche[num].time)/1000.0>30.0))
		  {
			  int result= proxy.send(8080, num);
			  Record record=new Record(); 
			  record.time=currTime; 
			  record.value=result; 
			  catche[num]=record;
			  JFrame parent = new JFrame();
		      JOptionPane.showMessageDialog(parent,"Odd number, output uses the remote result"+result );
			  return result;
		  }
		  else
		  {
			  JFrame parent = new JFrame();
		      JOptionPane.showMessageDialog(parent,"Odd number, output uses the local result"+catche[num].value );
			   return catche[num].value;
		  }
	    
	  } 
	
}


	  

	



